/*
  OMPi OpenMP Compiler
  == Copyright since 2001 the OMPi Team
  == Dept. of Computer Science & Engineering, University of Ioannina

  This file is part of OMPi.

  OMPi is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  OMPi is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with OMPi; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
*/

/* x_teams.h -- transform target teams constructs */

#ifndef __X_TEAMS_H__
#define __X_TEAMS_H__

#include "ast.h"
#include "x_cars.h"

extern void xform_teams(aststmt *t);
extern void xform_targetteams_default(aststmt *t);
extern void xform_targetteams_cuda(aststmt *t);
extern void xform_targetteams(aststmt *t, targstats_t *ts, astexpr targetparams, bool is_cuda);
extern void xform_teamsdist(aststmt *t);
extern void xform_teamsdistsimd(aststmt *t);
extern void xform_teamsdistparfor(aststmt *t);
extern void xform_teamsdistparforsimd(aststmt *t);
extern void xform_targetteamsdistsimd(aststmt *t);
extern void xform_targetteamsdistparfor(aststmt *t);
extern void xform_targetteamsdistparforsimd(aststmt *t);
#endif
